/*
	La version toujours plus dveloppe de l'applet "maison"
	Possibilit de slectionner des figures et surtout de modifier
	leur taille avec la souris.

	(C) J. Ferber - Octobre 2000
*/

package maison;

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;


/** La classe MaisonApplet qui gre les interactions avec l'utilisateur.
*/
public class MaisonApp extends JFrame implements ActionListener, Runnable
{

        JPanel figPanel; // le panel qui contient tous les boutons
                           // pour les figures
    	DrawingPane drawPane;


	public MaisonApp() {
		getContentPane().setLayout(new BorderLayout());
		JPanel p = new JPanel();
		getContentPane().add(p,"North");

  		JButton b1 = new JButton("Select");
  		JButton b2 = new JButton("Grille");

		JButton b3 = new JButton("Couleur");
		JButton b4 = new JButton("Clear");
		JButton b5 = new JButton("Run");
		JButton b6 = new JButton("Stop");
		p.add(b1);
		p.add(b2);
		p.add(b3);
		p.add(b4);
		p.add(b5);
		p.add(b6);

		b1.addActionListener(this);
		b2.addActionListener(this);
		b3.addActionListener(this);
		b4.addActionListener(this);
		b5.addActionListener(this);
		b6.addActionListener(this);

		figPanel = new JPanel(new GridLayout(4,1));
		getContentPane().add(figPanel,"West");

  		drawPane=new DrawingPane();
    	getContentPane().add(drawPane,"Center");
		drawPane.setPreferredSize(new Dimension(600,400));

        installFigure("Rectangle");
        installFigure("Oval");
        installFigure("Ligne");
        installFigure("Maison");

		// pour sortir de l'application 
		addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

		pack();
		show();

	}

	public static void main(String[] args){
		new MaisonApp();
	}

	// l'animation

    int delay = 30;
    
  	Thread process=null;
	protected boolean running;
	long iteration=0;

	/* la methode qui dclenche l'animation 
	**/
	void animate(){
	  if (!running){
		iteration=0;
	  	running = true;
      	process = new Thread(this);
      	// process.setPriority(Thread.MAX_PRIORITY);
      	process.start();
      }
    }
    
    public void stop(){
		running = false;
	}

    public void run()
    {
      while (running) {
		// if (showIteration) 
		//	System.out.println("iteration: " + iteration);
		drawPane.runFigures();
      	repaint();
	
		iteration++;
		
	  	try {process.sleep(delay);}
		catch (InterruptedException e) 	{
			running = false; break;
		}
	  }
    }


	public void actionPerformed(ActionEvent e) {
		String c = e.getActionCommand();

		if (c.equals("Select")){
      		drawPane.setMode(DrawingPane.MODE_SELECT);
  		} else if (c.equals("Couleur")) {
        	drawPane.incrColor();
  		} else if (c.equals("Grille")) {
			drawPane.toggleGrid();
		} else if (c.equals("Clear")) {
			drawPane.clear();
		} else if (c.equals("Run")) {
			animate();
		} else if (c.equals("Stop")) {
			stop();
		}
	}

        void installFigure(String name){
            Button b = new Button(name);
            figPanel.add(b);
            b.addActionListener(new ActionListener(){
                  public void actionPerformed(ActionEvent ev){
					  drawPane.unselect(true);
                      drawPane.createFigure(ev.getActionCommand());

                  }
              });
        }


}
